//    RW Shell
// ==============
// Robowaifu Shell, and General Inboard Systems Library
// -Part of the RW Foundations suite of libraries

// Filename: ./include/shell/shell.hpp
// -Declarations of the baseline RW Shell library

#pragma once

#include "incls_all.hpp"

namespace rw::shell {

//------------------------------------------------------------------------------
class Shell_b : public RW {
 public:
  Shell_b();                                    // default ctor
  explicit Shell_b(std::string const& handle);  // tag-parm'd ctor
};

//------------------------------------------------------------------------------
class Shell : public Shell_b {
 public:
  Shell();                                    // default ctor
  explicit Shell(std::string const& handle);  // tag-parm'd ctor

  inline auto electro() const -> Electro& { return electro_; }

 private:
  unique_ptr<Electro_b> _electro_{make_unique<Electro_b>("shell_electro")};

  Electro& electro_{reference_to<Electro>(_electro_.get())};
};

}  // namespace rw::shell

//    --=^=--

// "______"

// rw_shell_lib.v211127
// Copyright (2021)
// License MIT (Expat) https://opensource.org/licenses/MIT
