//  RW Foundations
// ================
// The RW Foundational Libraries

// Filename: ./src/rw/rw.cpp
// -Definitions of the baseline RW library

#include "incls_all.hpp"

namespace rw {

//------------------------------------------------------------------------------
RW::RW() {}

//------------------------------------------------------------------------------
RW::RW(std::string const& handle) : tip_{handle, rw_id++, this} {}

//------------------------------------------------------------------------------
RW::~RW() {
  // prt_tag(tip_, "via RW::~RW() dtor \t");  // DIAG:
}

//------------------------------------------------------------------------------
auto RW::my_hdl() const -> std::string {
  return tip_.hdl;
}

//------------------------------------------------------------------------------
auto RW::my_id() const -> unsigned int {
  return tip_.id;
}

//------------------------------------------------------------------------------
auto RW::my_addr() const -> RW* {
  return tip_.ptr;
}

//------------------------------------------------------------------------------
auto RW::tt() const -> Tip const& {
  return tip_;
}

//------------------------------------------------------------------------------
unsigned long int RW::rw_id{0};  // private static member

}  // namespace rw

//    --=^=--

// "So is it true Sempai? Are robowaifus really better than any human woman?"

// rw_foundations_lib.v211127
// Copyright (2021)
// License MIT(Expat) https://opensource.org/licenses/MIT
